package org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.generators;
import java.io.File;
import java.net.URL;
import java.io.IOException;
import java.io.InputStream;
import java.util.LinkedHashMap;
import java.io.StringWriter;
import org.apache.commons.io.IOUtils;
import org.apache.xmlbeans.XmlObject;
import org.gcube.dataanalysis.wps.statisticalmanager.synchserver.bindings.*;
import org.n52.wps.algorithm.annotation.*;
import org.n52.wps.io.data.*;
import org.n52.wps.io.data.binding.complex.*;
import org.n52.wps.io.data.binding.literal.*;
import org.n52.wps.server.*;import org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mapping.AbstractEcologicalEngineMapper;import org.n52.wps.server.*;import org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.*;
@Algorithm(statusSupported=true, title="OCCURRENCES_SUBTRACTION", abstrakt="A transducer algorithm that produces a table resulting from the difference between two occurrence points tables where points equivalence is identified via user defined comparison thresholds. Works with up to 10000 points per table. Between two Ocurrence Sets, keeps the elements of the Left Set that are not similar to any element in the Right Set.", identifier="org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.generators.OCCURRENCES_SUBTRACTION", version = "1.1.0")
public class OCCURRENCES_SUBTRACTION extends AbstractEcologicalEngineMapper implements IGenerator{
@LiteralDataInput(abstrakt="Name of the parameter: final_Table_Name. the name of the produced table", defaultValue="Occ_", title="the name of the produced table", identifier = "final_Table_Name", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setfinal_Table_Name(String data) {inputs.put("final_Table_Name",data);}
@ComplexDataInput(abstrakt="Name of the parameter: leftTableName. the First table containing the occurrence points (up to 10 000) [a http link to a table in UTF-8 encoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", title="the First table containing the occurrence points (up to 10 000) [a http link to a table in UTF-8 encoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", maxOccurs=1, minOccurs=1, identifier = "leftTableName", binding = GenericFileDataBinding.class)	public void setleftTableName(GenericFileData file) {inputs.put("leftTableName",file);}
@ComplexDataInput(abstrakt="Name of the parameter: rightTableName. the Second table containing the occurrence points (up to 10 000) [a http link to a table in UTF-8 encoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", title="the Second table containing the occurrence points (up to 10 000) [a http link to a table in UTF-8 encoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", maxOccurs=1, minOccurs=1, identifier = "rightTableName", binding = GenericFileDataBinding.class)	public void setrightTableName(GenericFileData file) {inputs.put("rightTableName",file);}
@LiteralDataInput(abstrakt="Name of the parameter: longitudeColumn. column with longitude values [the name of a column from leftTableName]", defaultValue="decimallongitude", title="column with longitude values [the name of a column from leftTableName]", identifier = "longitudeColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setlongitudeColumn(String data) {inputs.put("longitudeColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: latitudeColumn. column with latitude values [the name of a column from leftTableName]", defaultValue="decimallatitude", title="column with latitude values [the name of a column from leftTableName]", identifier = "latitudeColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setlatitudeColumn(String data) {inputs.put("latitudeColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: recordedByColumn. column with RecordedBy values [the name of a column from leftTableName]", defaultValue="recordedby", title="column with RecordedBy values [the name of a column from leftTableName]", identifier = "recordedByColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setrecordedByColumn(String data) {inputs.put("recordedByColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: scientificNameColumn. column with Scientific Names [the name of a column from leftTableName]", defaultValue="scientificname", title="column with Scientific Names [the name of a column from leftTableName]", identifier = "scientificNameColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setscientificNameColumn(String data) {inputs.put("scientificNameColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: eventDateColumn. column with EventDate values [the name of a column from leftTableName]", defaultValue="eventdate", title="column with EventDate values [the name of a column from leftTableName]", identifier = "eventDateColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void seteventDateColumn(String data) {inputs.put("eventDateColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: lastModificationColumn. column with Modified values [the name of a column from leftTableName]", defaultValue="modified", title="column with Modified values [the name of a column from leftTableName]", identifier = "lastModificationColumn", maxOccurs=1, minOccurs=1, binding = LiteralStringBinding.class) public void setlastModificationColumn(String data) {inputs.put("lastModificationColumn",data);}
@LiteralDataInput(abstrakt="Name of the parameter: spatialTolerance. the tolerance in degree for assessing that two points could be the same", defaultValue="0.5", title="the tolerance in degree for assessing that two points could be the same", identifier = "spatialTolerance", maxOccurs=1, minOccurs=1, binding = LiteralDoubleBinding.class) public void setspatialTolerance(Double data) {inputs.put("spatialTolerance",""+data);}
@LiteralDataInput(abstrakt="Name of the parameter: confidence. the overall acceptance similarity threshold over which two points are the same - from 0 to 100", defaultValue="80", title="the overall acceptance similarity threshold over which two points are the same - from 0 to 100", identifier = "confidence", maxOccurs=1, minOccurs=1, binding = LiteralDoubleBinding.class) public void setconfidence(Double data) {inputs.put("confidence",""+data);}
@ComplexDataOutput(abstrakt="Name of the parameter: OutputTable. The output table containing the processed points [a http link to a table in UTF-8 ecoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", title="The output table containing the processed points [a http link to a table in UTF-8 ecoding following this template: (OCCURRENCE_SPECIES) http://goo.gl/4ExuR5]", identifier = "OutputTable", binding = CsvFileDataBinding.class)	public GenericFileData getOutputTable() {URL url=null;try {url = new URL((String) outputs.get("OutputTable")); return new GenericFileData(url.openStream(),"text/csv");} catch (Exception e) {e.printStackTrace();return null;}}
@ComplexDataOutput(abstrakt="Output that is not predetermined", title="NonDeterministicOutput", identifier = "non_deterministic_output", binding = GenericXMLDataBinding.class)
 public XmlObject getNon_deterministic_output() {return (XmlObject) outputs.get("non_deterministic_output");}
@Execute	public void run() throws Exception {		super.run();	} }